local lastDamageWeapon = null;
local lastDamageAttacker = null;

OnSelfEvent("OnTakeDamage", 9999, function(player, params)
{
    lastDamageWeapon = params.weapon;
    lastDamageAttacker = params.attacker;
});

OnSelfEvent("player_hurt", function(params)
{
    if (!IsValid(lastDamageWeapon) || lastDamageAttacker == self)
        return;
    local weaponId = GetItemId(lastDamageWeapon);

     //Black Box self-healing
    if (weaponId == 228)
    {
        lastDamageAttacker.Heal(clampCeiling(20, params.damageamount / 4.5));
    }
    //Blutsauger self-healing
    if (weaponId == 36)
    {
        lastDamageAttacker.Heal(3);
    }
    //Double Donk Extra damage
    if (weaponId == 996 && params.minicrit && params.damageamount > 20 && self.GetHealth() > 0)
    {
        OnNextTick(function(weapon, attacker, damage) {
            self.TakeDamageCustom(
                attacker,
                attacker,
                weapon,
                Vector(),
                Vector(),
                damage * 0.5,
                0,
                0);
        }, lastDamageWeapon, lastDamageAttacker, params.damageamount)
    }
    lastDamageWeapon = null;
});